package util.ballot_counter;

import java.text.DecimalFormat;
import java.util.Vector;

public class ExperimentOne {
	public static String DL = "\t";
	public static int MODE_FLAT = 0;
	public static int MODE_HYBRID = 1;
	public static int MODE_LINEAR = 2;
	
	public static double TOTAL_BALLOTS = 500;
	public static double increment = 0.05;
	public static DecimalFormat df = new DecimalFormat("0.000");
	
	public static iCountingSystem[] systems = new iCountingSystem[]{
		/*
		//new CS_NTV_AnalogAllocation(),
		new CS_NTV_DigitalAllocation(),
		new CS_NTV_Approval(),
		new CS_NTV_NVotes(),

		new CS_NTV_Borda(),
		
		//new CS_MTV_AnalogAllocation(),
		new CS_MTV_DigitalAllocation(),
		new CS_MTV_Approval(),
		new CS_MTV_NVotes(),
		
		new CS_STV_Common(),
		new CS_STV_Correct(),  //since this is NP time, it becomes impractical at somewhere between 15 and 20 candidates.
		*/
		new CS_STV_Hare_Incorrect(),  //since this is NP time, it becomes impractical at somewhere between 15 and 20 candidates.
	};
	public static void main(String[] args) {
		/*
		int s = 5;
		MultiBallot.num_votes = s; 
		MultiBallot.num_allocs = s*2; 
		MultiBallot.approval_threshold = 1.0;
		
		Vector<MultiBallot> mb = run(0.1,s,true,MODE_LINEAR,false);
		
		for( MultiBallot b : mb) {
			System.out.println(mb.toString());
		}
		
		
		new CS_STV_Common().getWinners(mb, s);
		
		System.out.println();
		System.out.println(AllocationElection.reasoning);
		System.out.println(STVElection2.reasoning);
		System.exit(0);
		*/
		
		for( int seats = 1; seats < 9; seats++) {
			for( double pct_d = 0.0; pct_d <= 0.600001; pct_d += increment) {
				run(pct_d,seats,false,0,true);
				run(pct_d,seats,false,2,true);
				run(pct_d,seats,true,0,true);
				run(pct_d,seats,true,2,true);
			}
		}
		/*
		for( int seats = 1; seats < 9; seats++) {
			for( double pct_d = 0.0; pct_d <= 0.600001; pct_d += increment) {
				run(pct_d,seats,false,0,true);
			}
		}
		for( int seats = 1; seats < 9; seats++) {
			for( double pct_d = 0.0; pct_d <= 0.600001; pct_d += increment) {
				run(pct_d,seats,false,2,true);
			}
		}
		for( int seats = 1; seats < 9; seats++) {
			for( double pct_d = 0.0; pct_d <= 0.600001; pct_d += increment) {
				run(pct_d,seats,true,0,true);
			}
		}
		for( int seats = 1; seats < 9; seats++) {
			for( double pct_d = 0.0; pct_d <= 0.600001; pct_d += increment) {
				run(pct_d,seats,true,2,true);
			}
		}
		*/
	}
	
	public static Vector<MultiBallot> run(double pct_dem, int seats, boolean candidates_proportional, int mode, boolean print) {
		/*
	public static int num_votes = 3;
	public static int num_allocs = 6;
	public static double approval_threshold = 1.0;
			 */
		MultiBallot.num_votes = seats; 
		MultiBallot.num_allocs = seats*2; 
		MultiBallot.approval_threshold = 1.0;
		
		int dc = candidates_proportional ? seats : (int)Math.round(2.0*pct_dem*(double)seats);
		int rc = candidates_proportional ? seats : (int)Math.round(2.0*(1.0-pct_dem)*(double)seats);
		
		int dp = (int)Math.round(pct_dem*TOTAL_BALLOTS);
		int rp = (int)Math.round((1.0-pct_dem)*TOTAL_BALLOTS);
		
		Vector<MultiBallot> mbs = new Vector<MultiBallot>();
		
		if( mode == MODE_FLAT) {
			addRandomPartyBallots(0,dc,dc+rc,dp,mbs);
			addRandomPartyBallots(dc,dc+rc,dc+rc,rp,mbs);
		} else 
		if( mode == MODE_HYBRID) {
			addRandomPartyBallots(0,dc,dc+rc,dp/2,mbs);
			addRandomPartyBallots(dc,dc+rc,dc+rc,rp/2,mbs);
			addLinearPartyBallots(0,dc,dc+rc,dp/2,mbs);
			addLinearPartyBallots(dc,dc+rc,dc+rc,rp/2,mbs);
		} else 
		if( mode == MODE_LINEAR) {
			addLinearPartyBallots(0,dc,dc+rc,dp,mbs);
			addLinearPartyBallots(dc,dc+rc,dc+rc,rp,mbs);
		}
		System.out.print(""+seats+DL+df.format(pct_dem)+DL+(mode == 0 ? "FLAT" : mode == 1 ? "HYBRID" : "LINEAR")+DL+candidates_proportional+DL);
		if( print) {
			printResults(mbs,  seats,  dc); 
		}
		return mbs;
	}
	public static void printResults(Vector<MultiBallot> mbs, int seats, int dc) {
		for( int i = 0; i < systems.length; i++) {
			int[] winners = systems[i].getWinners(mbs,seats);
			double dsp = 0;
			for( int j = 0; j < winners.length; j++) {
				if( winners[j] < dc && winners[j] >= 0) {
					dsp += 1.0/(double)seats;
				}
			}
			System.out.print(""+arrayToString(winners)+DL);
			System.out.print(""+df.format(dsp)+DL);
		}
		System.out.println();
	}
	public static String arrayToString(int[] ii) {
		String s = "";
		for( int i = 0; i < ii.length; i++) {
			if( i > 0) {
				s +=",";
			}
			s+= ""+ii[i];
		}
		return s;
	}
	
	public static void addRandomPartyBallots(int start, int end, int candidates, int n_ballots, Vector<MultiBallot> mbs) {
		double other_votes = 0.001;
		for( int n = 0; n < n_ballots; n++) {
			double[] dd = new double[candidates];
			
			double tot = 0;
			for( int i = 0; i < start; i++) {
				dd[i] = Math.random()*other_votes;
				tot += dd[i];
			}
			for( int i = start; i < end; i++) {
				dd[i] = Math.random();
				tot += dd[i];
			}
			for( int i = end; i < candidates; i++) {
				dd[i] = Math.random()*other_votes;
				tot += dd[i];
			}
			
			if( tot == 0) {
				tot = 1;
			} else {
				tot = 1.0/tot;
			}

			for( int i = 0; i < candidates; i++) {
				dd[i] *= tot;
			}
			mbs.add(new MultiBallot(1,dd));
		}
	}
	public static void addLinearPartyBallots(int start, int end, int candidates, int n_ballots, Vector<MultiBallot> mbs) {
		double[] dd = new double[candidates];
		
		double cur = 1;
		double tot = 0;
		for( int i = start; i < end; i++) {
			dd[i] = cur;
			tot += dd[i];
			cur++;
		}
		for( int i = start; i < end; i++) {
			dd[i] /= tot;
		}
		mbs.add(new MultiBallot(n_ballots,dd));
	}

}
